Subject: Re: FCC driver for Motorola MPC82xx - an error found

From: Scott Wood <[email-masked]>
Date: Mon, 7 Dec 2015 19:29:10 -0600

On Tue, 2015-11-24 at 05:19 -0700, Martin Roth wrote:
> I was looking for an error on MPC8270 processor 100 Mbps Ethernet FCC port. 
> The port may become locked if it is set to AUTO, while the peer is forced to
> 100 Mbs full duplex (non AUTO).
> I was looking for an error in the area of collision handling of the driver.
> It looks like I found the problem.
> 
> The error is at line 555:
> http://lxr.free-electrons.com/source/drivers/net/ethernet/freescale/fs_enet/
> mac-fcc.c#L555
> 
> The problem is that the last descriptor address is not calculated correctly.
> 
> Instead of
>    last_tx_bd = fep->tx_bd_base + (fpi->tx_ring * sizeof(cbd_t)); 
> The fix should be:
>    last_tx_bd = fep->tx_bd_base + ((fpi->tx_ring-1)* sizeof(cbd_t));
> 
> Is it a bug? 
> Thanks,
> Martin Roth

Yes, it looks like a bug.  Could you send a patch to the netdev list and
maintainer?

-Scott